/*
 * File:   LCD.h
 * Author: DG
 *
 * Created on 1 stycznia 2016, 20:16
 */
#use delay (clock = 8000000)     //page 34 of datasheet  

#USE FAST_IO(a) //IO port is faster, becouse it not chacking direction 
#USE FAST_IO(c) 
#USE FAST_IO(c) 
#USE FAST_IO(f) 

// SPI registers 
#word LCD_SSPBUF     =  0x0FC9   // SPI1BUF 
#word LCD_SPICON1    =  0x0FC6   // SPI1CON1 
#word LCD_SPISTAT    =  0x0FC7   // SPI1STAT 
#word LCD_SPI_IF     =  0x0F9E   // PIR1 
#define SSP1IF_BIT        0x03 

// ----------- PICDEM HPC Explorer 18 LCD defines -> uP to expander
#define   LCD_CS            (PIN_A2)          //LCD chip select 
#define   LCD_RST            (PIN_F6)          //LCD Reset 
#define   LCD_CLK            (PIN_C3)       
#define   LCD_SI             (PIN_C5) 

// ------EVERYTHING WE NEDD IS IN DECLARATION ABOW------------------------------ 
// PICDEM HPC Explorer 18 LCD controlled via MCP923S17 
void LCDBusy(void); 
void WritePortA(char b); 
void WritePortB(char b); 
void d_write(char b); 
void i_write(char b); 
void LCDLine_1(void); 
void LCDLine_2(void); 
void LCDClear(void); 
void InitWrite(char b); 
void InitPortA_SPI(char b); 
void InitPortB_SPI(char b); 
void InitSPI(void); 
void LCDInit(void); 

#ifndef LCD_OK_H
#define LCD_OK_H

//***************************************************************** 
// LCD busy delay 
//***************************************************************** 
void LCDBusy(void) 
{ 
    delay_us(100); 
} 
//***************************************************************** 
// Write to MCP923S17 Port A 
//***************************************************************** 
void WritePortA(char b) 
{ 
    output_low(LCD_CS);    

   LCD_SSPBUF = 0x40; 
   while(! bit_test(LCD_SPI_IF,SSP1IF_BIT)); 
    bit_clear(LCD_SPI_IF,SSP1IF_BIT); 

   LCD_SSPBUF = 0x12; 

   while(! bit_test(LCD_SPI_IF,SSP1IF_BIT)); 
    bit_clear(LCD_SPI_IF,SSP1IF_BIT); 
    
   LCD_SSPBUF = b; 

   while(! bit_test(LCD_SPI_IF,SSP1IF_BIT)); 
    bit_clear(LCD_SPI_IF,SSP1IF_BIT); 
    
   output_high(LCD_CS); 
} 
//***************************************************************** 
// Write to MCP923S17 Port B 
//***************************************************************** 
void WritePortB(char b) 
{ 
    output_low(LCD_CS);    
    
   LCD_SSPBUF = 0x40; 

   while(! bit_test(LCD_SPI_IF,SSP1IF_BIT)); 
    bit_clear(LCD_SPI_IF,SSP1IF_BIT); 
    
   LCD_SSPBUF = 0x13; 

   while(! bit_test(LCD_SPI_IF,SSP1IF_BIT)); 
    bit_clear(LCD_SPI_IF,SSP1IF_BIT); 
    
   LCD_SSPBUF = b; 

   while(! bit_test(LCD_SPI_IF,SSP1IF_BIT)); 
    bit_clear(LCD_SPI_IF,SSP1IF_BIT); 
    
   output_high(LCD_CS); 
} 
//***************************************************************** 
// Write the data to the display 
//***************************************************************** 
void d_write(char b) 
{ 
   WritePortA(0x80); 
   LCDBusy(); 
   WritePortB(b); 
    delay_us(10); 
   WritePortA(0xC0); 
    delay_us(10); 
   WritePortA(0x00); 
   //TXREG = b;               //carriage return 
   //while(!LCD_TXSTA_TRMT);      //wait for data TX 
   //LCD_TXSTA_TRMT = 0; 
} 
//***************************************************************** 
// Send a instruction to the display 
//***************************************************************** 
void i_write(char b) 
{ 
   WritePortA(0x00); 
   LCDBusy(); 
   WritePortB(b); 
    delay_us(10); 
   WritePortA(0x40); 
    delay_us(10); 
   WritePortA(0x00); 
} 
//***************************************************************** 
// Write to line 1 of the display 
//***************************************************************** 
void LCDLine_1(void) 
{ 
   i_write(0x80); 
} 
//***************************************************************** 
// Write to line 1 of the display 
//***************************************************************** 
void LCDLine_2(void) 
{ 
   i_write(0xC0); 
} 
//***************************************************************** 
// To clear the display 
//***************************************************************** 
void LCDClear(void) 
{ 
   i_write(0x01); 
} 
//****************************************************************** 
// Function to write to the PORT 
//****************************************************************** 
void InitWrite(char b) 
{ 
   WritePortA(0); 
   WritePortB(b); 
    delay_us(10); 
   WritePortA(0x40); 
    delay_us(20); 
   WritePortA(0); 
} 
//***************************************************************** 
// Initialize MCP923S17 Port A 
//***************************************************************** 
void InitPortA_SPI(char b) 
{ 
    output_low(LCD_CS);    
   LCD_SSPBUF = 0x40; 

   while(! bit_test(LCD_SPI_IF,SSP1IF_BIT)); 
    bit_clear(LCD_SPI_IF,SSP1IF_BIT); 
    
   LCD_SSPBUF = 0x00; 

   while(! bit_test(LCD_SPI_IF,SSP1IF_BIT)); 
    bit_clear(LCD_SPI_IF,SSP1IF_BIT); 
    
   LCD_SSPBUF = b; 

   while(! bit_test(LCD_SPI_IF,SSP1IF_BIT)); 
    bit_clear(LCD_SPI_IF,SSP1IF_BIT); 
    
    output_high(LCD_CS);    
} 
//***************************************************************** 
// Initialize MCP923S17 Port B 
//***************************************************************** 
void InitPortB_SPI(char b) 
{ 
    output_low(LCD_CS);    
   LCD_SSPBUF = 0x40; 
   while(! bit_test(LCD_SPI_IF,SSP1IF_BIT)); 
    bit_clear(LCD_SPI_IF,SSP1IF_BIT); 
    
   LCD_SSPBUF = 0x01; 
   while(! bit_test(LCD_SPI_IF,SSP1IF_BIT)); 
    bit_clear(LCD_SPI_IF,SSP1IF_BIT); 
    
   LCD_SSPBUF = b; 
   while(! bit_test(LCD_SPI_IF,SSP1IF_BIT)); 
    bit_clear(LCD_SPI_IF,SSP1IF_BIT); 
    
    output_high(LCD_CS);    
} 
//***************************************************************** 
// Initialize MCP923S17 SPI 
//***************************************************************** 
void InitSPI(void) 
{ 
    // Set SSPM1 bit and SSPEN bit 
   LCD_SPICON1 = 0x22; 

    // Set CKE bit 
   LCD_SPISTAT = 0x40; 

    // Set Master Synchronous Serial Port Interrupt Flag bit bit in PIR1 to 0 
    bit_clear(LCD_SPI_IF,SSP1IF_BIT); 
} 
//****************************************************************** 
// LCD Initialization function 
//****************************************************************** 
void LCDInit(void) 
{ 
    // Set PIN_A2 (chip sel) to output. 
    set_tris_a(0x0FB); 

    // Set Pin_C3 (clk ) and pin_C5 (si) to output. 
    set_tris_c(0x0D7); 

    // Set PIN_D0  to output. 
    set_tris_d(0x0FE); 

    // Set Pin_F6 (reset ) to output. 
    set_tris_f(0x0BF); 
    
    
    output_high(LCD_CS); 
    delay_us(50); 

    output_low(LCD_RST); 
    delay_us(50); 
    output_high(LCD_RST); 
    
   InitSPI(); 
   InitPortA_SPI(0); 
   InitPortB_SPI(0); 
    
   WritePortA(0); 
    
    delay_us(50); 
   InitWrite(0x3C);            //0011NFxx 
    
    delay_us(50); 
   InitWrite(0x0C);            //Display Off 
    
    delay_us(50); 
   InitWrite(0x01);            //Display Clear 
    
    delay_us(50); 
   InitWrite(0x06);            //Entry mode 
}
#endif
